//.............................................................................
//
//          LCD soft
//														V01 L01		2013.05/22
//.............................................................................

#include "string.h"

//========================================================
//		DATA
//========================================================
#define     LCD_PORT1		PORTA
#define     LCD_PORT2		PORTB
#define     LCD_TRIS1		TRISA
#define     LCD_TRIS2		TRISB

const int	CMD_0	= 0b00000000 ;
const int	CMD_1	= 0b00000001 ;
const int	CMD_2	= 0b00000010 ;
const int	CMD_3	= 0b00000011 ;
const int	CMD_4	= 0b00000100 ;
const int	CMD_6	= 0b00000110 ;

const int	LCD_CLS		= 0x01 ;
const int	LCD_LINE1	= 0x80 ;
const int	LCD_LINE2	= 0xC0 ;

const int	TRIS_0	= 0b00000000 ;
const int	TRIS_1	= 0b00001111 ;

const int	CHK_1	= 0b00001000 ;


//========================================================
//						LCD
//========================================================
// =========================================
//			LCD wait
// =========================================
void lcd_wait( int tLcdWC ){
		static int	ii1,ii2 ;
		static int	tSt1 ;
		static int	tSt2 ;
    LCD_TRIS2 = ( TRIS_1 );     // PORT o͐ݒ
	for( ii1 = tLcdWC ; ii1 > 0 ; ii1-- ){
		for( ii2 = 10 ; ii2 > 0 ; ii2-- ){
			LCD_PORT1	= CMD_1;
			LCD_PORT1	= CMD_3;
			tSt1	= LCD_PORT2 ;
			LCD_PORT1	= CMD_1;
			LCD_PORT1	= CMD_3;
			tSt2	= LCD_PORT2 ;
			LCD_PORT1	= CMD_0;
			tSt1 &= CHK_1 ;
			if( tSt1 == 0 ){
				ii1 = 0 ;
				ii2 = 0 ;
			}
		}
	}
    LCD_TRIS2 = ( TRIS_0 );     // PORT o͐ݒ
}

// =========================================
//			LCD wait 2
// =========================================
void lcd_wait2( int tLcdWC ){
		static int	ii1,ii2 ;
		static int	tSt1 ;
		static int	tSt2 ;
    LCD_TRIS2 = ( TRIS_1 );     // PORT o͐ݒ
	for( ii1 = tLcdWC ; ii1 > 0 ; ii1-- ){
		for( ii2 = 10 ; ii2 > 0 ; ii2-- ){
			LCD_PORT1	= CMD_1;
			LCD_PORT1	= CMD_3;
			tSt1	= LCD_PORT2 ;
			LCD_PORT1	= CMD_1;
			LCD_PORT1	= CMD_3;
			tSt2	= LCD_PORT2 ;
			LCD_PORT1	= CMD_0;
			tSt1 &= CHK_1 ;
			if( tSt1 == 0 ){
				ii2 = 0 ;
			}
		}
	}
    LCD_TRIS2 = ( TRIS_0 );     // PORT o͐ݒ
}

// =========================================
//			command WR
// =========================================
void lcd_cmd1( int tCmd_chr ){
		static int tCmdChr1 ;
	tCmdChr1	 = tCmd_chr ;
	tCmdChr1	&= 0xf0 ;
	tCmdChr1	/= 0x10 ;
	LCD_PORT1	= CMD_0 ;
	LCD_PORT2	= tCmdChr1 ;
	LCD_PORT1	= CMD_2 ;
	LCD_PORT1	= CMD_0 ;
	lcd_wait( 3 );
}

// =========================================
//			command WR 2
// =========================================
void lcd_cmd2( int tCmd_chr ){
		static int tCmdChr1 ;
		static int tCmdChr2 ;
	tCmdChr1	 = tCmd_chr ;
	tCmdChr1	&= 0xf0 ;
	tCmdChr1	/= 0x10 ;
	tCmdChr2	 = tCmd_chr ;
	tCmdChr2	&= 0x0f ;
	LCD_PORT1	= CMD_0 ;
	LCD_PORT2	= tCmdChr1 ;
	LCD_PORT1	= CMD_2 ;
	LCD_PORT1	= CMD_0 ;
	LCD_PORT2	= tCmdChr2 ;
	LCD_PORT1	= CMD_2 ;
	LCD_PORT1	= CMD_0 ;
	lcd_wait( 3 );
}

// =========================================
//			data WR
// =========================================
void lcd_dat( int tData_chr ){
		static int tDataOut1 ;
		static int tDataOut2 ;
	tDataOut1  = tData_chr ;
	tDataOut1 &= 0xf0 ;
	tDataOut1 /= 0x10 ;
	tDataOut2  = tData_chr ;
	tDataOut2 &= 0x0f ;
	LCD_PORT1	= CMD_0 ;
	LCD_PORT1	= CMD_4 ;
	LCD_PORT2	= tDataOut1 ;
	LCD_PORT1	= CMD_6 ;
	LCD_PORT1	= CMD_4 ;
	LCD_PORT2	= tDataOut2 ;
	LCD_PORT1	= CMD_6 ;
	LCD_PORT1	= CMD_4 ;
	lcd_wait2( 1 );
}
//========================================================
//						LCD\
//========================================================
// =========================================
//			data WR chr HOME
// =========================================
void	lcd_chr_out0( char tOchr[] ){
		static int		chr_len ;
		static int		ii0 ;
	chr_len = strlen( tOchr ) ;
	lcd_cmd2( LCD_CLS );
	for( ii0 = 0 ; chr_len > ii0 ; ii0++ ){
		lcd_dat( tOchr[ii0] );
	}
}

// =========================================
//			data WR chr ADD
// =========================================
void	lcd_chr_outadd( char tOchr[] ){
		static int		chr_len ;
		static int		ii0 ;
	chr_len = strlen( tOchr ) ;
	for( ii0 = 0 ; chr_len > ii0 ; ii0++ ){
		lcd_dat( tOchr[ii0] );
	}
}

// =========================================
//			data WR chr LINE1
// =========================================
void	lcd_chr_out1( char tOchr[] ){
		static int		chr_len ;
		static int		ii0 ;
	chr_len = strlen( tOchr ) ;
	lcd_cmd2( LCD_LINE1 );
	for( ii0 = 0 ; chr_len  > ii0 ; ii0++ ){
		lcd_dat( tOchr[ii0] );
	}
}

// =========================================
//			data WR chr LINE2
// =========================================
void	lcd_chr_out2( char tOchr[] ){
		static int		chr_len ;
		static int		ii0 ;
	chr_len = strlen( tOchr ) ;
	lcd_cmd2( LCD_LINE2 );
	for( ii0 = 0 ; chr_len > ii0 ; ii0++ ){
		lcd_dat( tOchr[ii0] );
	}
}

// =========================================
//			data WR No.
// =========================================
void	lcd_no_out( int tOno ){
		static int		tNoChr ;
	tNoChr = (char)( tOno + 0x30 );
	lcd_dat( tNoChr );
}


// ==================================================================
// ==================================================================
//
//      
//
// ==================================================================
// ==================================================================
void lcd_init( ){

//@PORTݒ
    LCD_TRIS1 = ( 0b00000000 );     // PORT o͐ݒ
    LCD_TRIS2 = ( 0b00000000 );     // PORT o͐ݒ
    LCD_PORT1 = ( 0b00000000 );     // PORT l
    LCD_PORT2 = ( 0b00000000 );     // PORT l

//@kbc
	lcd_wait( 50 );
	lcd_cmd1( 0x33 );
	lcd_wait( 50 );
	lcd_cmd1( 0x33 );
	lcd_wait( 3 );
	lcd_cmd1( 0x33 );
	lcd_cmd1( 0x22 );

	lcd_cmd2( 0x2E );
	lcd_cmd2( 0x08 );
	lcd_cmd2( 0x0D );
	lcd_wait( 30 );
	lcd_cmd2( 0x06 );
}

// ==================================================================
// ==================================================================
// ==================================================================
// ==================================================================
// ==================================================================
