//.............................................................................
//
//          LED soft
//														V01 L01		2013.05/22
//.............................................................................

//========================================================
//		DATA
//========================================================
#define     LED_PORT		PORTD
#define     LED_TRIS		TRISD

const int	cLoopWait	= 0x200;
const int	cLedWait	= 0x10;
const int	cLedStData	= 0b00000001;
const int	cLedMSB		= 0b10000000 ;
const int	cLedLSB		= 0b00000001 ;

int			gLEDwait	= 0 ;
int			gLEDwcnt	= 0 ;
int			gLedData 	= 0 ;
int			gLedCont	= 0 ;
int			gLEDindex	= 0 ;

// =================================================
//          wait
// =================================================
void wait_loop( ){
		static int		ii0,ii1,ii2 ;
	for( ii0 = gLEDwait ; ii0 > 0 ; ii0-- ){
		for( ii1 = cLoopWait ; ii1 > 0 ; ii1-- ){
		}
	}
}

// =================================================
//          wait dec	type 1
// =================================================
void wait_dec1( ){
	gLEDwait--;
	if( !(gLEDwait) ){
		gLEDwait = cLedWait ;
	}
}

// =================================================
//          wait dec	type 2
// =================================================
void wait_dec2( ){
	gLEDwait--;
	if( !(gLEDwait) ){
		gLEDwait = cLedWait ;
	}
}

// =================================================
//          wait dec	type 3
// =================================================
void wait_dec3( ){
	if( gLEDwcnt ){
		gLEDwcnt--;
	}else{
		gLEDwcnt = cLedWait - gLEDwait;
		if( gLEDwait ){
			gLEDwait--;
		}else{
			gLEDwait = cLedWait ;
		}
	}
}

// =================================================
//          data chg	type 1
// =================================================
int data_chg1( int tDataIn ){
	    static int      tDataOut = 0 ;
	tDataOut = tDataIn ;
	tDataOut *= 2 ;
	if( tDataOut > 0x80 ){
		tDataOut = cLedStData ;
		wait_dec1() ;
	}
	return( tDataOut );
}

// =================================================
//          data chg	type 2
// =================================================
int data_chg2( int tDataIn ){
	    static int      tDataOut = 0 ;
	tDataOut = tDataIn ;
	if( gLEDindex ){
		tDataOut = tDataOut >> 1 ;
		if( tDataOut == cLedLSB ){
			gLEDindex = 0 ;
			wait_dec2() ;
		}
	}else{
		tDataOut = tDataOut << 1 ;
		if( tDataOut == cLedMSB ){
			gLEDindex = 1 ;
		}
	}
	return( tDataOut );
}

// =================================================
//          data chg	type 3
// =================================================
int data_chg3( int tDataIn ){
	    static int      tDataOut = 0 ;
	tDataOut = tDataIn ;
	if( gLEDindex ){
		tDataOut = tDataOut >> 1 ;
		if( tDataOut == cLedLSB ){
			gLEDindex = 0 ;
			wait_dec3() ;
		}
	}else{
		tDataOut = tDataOut << 1 ;
		if( tDataOut == cLedMSB ){
			gLEDindex = 1 ;
		}
	}
	return( tDataOut );
}

// =================================================
//          LED _
// =================================================
void led_set( int tLedData ){
		static int tLedOut ;
	tLedOut = 0x0ff - tLedData  ;
	tLedOut &= 0x0ff ;
	LED_PORT = tLedOut ;
}

// =================================================
//          LED 1bit _
// =================================================
void led_bset( int tLedData ){
		static int tLedOut ;
	tLedData--;
	tLedOut   = 1 ;
	tLedOut   = tLedOut<<tLedData ;
	tLedOut   = 0x0ff - tLedOut  ;
	tLedOut  &= 0x0ff ;
	LED_PORT  = tLedOut ;
}

// =================================================
//          LED 1bit _
// =================================================
void led_bset2( int tLedData ){
		static int tLedOut ;
	tLedData  = 2^tLedData ;
	tLedOut   = 0x0ff - tLedData  ;
	tLedOut  &= 0x0ff ;
	LED_PORT &= tLedOut ;
}


// ==================================================================
// ==================================================================
//      
// ==================================================================
// ==================================================================
void led_init( ){
    LED_PORT = ( 0b00000000 );     // PORT l
    LED_TRIS = ( 0b00000000 );     // PORT o͐ݒ

	gLedData	= cLedMSB ;
	gLEDindex	= 1 ;
	gLEDwait	= cLedWait ;
	gLEDwcnt	= 1 ;
}

// ==================================================================
// ==================================================================
// ==================================================================
// ==================================================================
// ==================================================================
